/**************************************************************************************
 * Copyright (C) 2008 EsperTech, Inc. All rights reserved.                            *
 * http://esper.codehaus.org                                                          *
 * http://www.espertech.com                                                           *
 * ---------------------------------------------------------------------------------- *
 * The software in this package is published under the terms of the GPL license       *
 * a copy of which has been included with this distribution in the license.txt file.  *
 **************************************************************************************/
package com.espertech.esper.view.stat.olap;

import com.espertech.esper.view.stat.olap.Dimension;

/**
 * DimensionMember models instances of dimensional members. A member is a single or multiple object derived from the
 * event property or properties of the dimension.
 */
public interface DimensionMember
{
    /**
     * Returns the dimension the member belongs to.
     * @return dimension that this member is a value of
     */
    public Dimension getDimension();

    /**
     * Returns member values.
     * @return array of member values
     */
    public Object[] getValues();
}
