package org.n52.swe.sas.bindings;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;

/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 *
 */
public class InvalidXMLContentException extends Exception {
	
	/**
	 * autogenerated serialVerionUID 
	 */
	private static final long serialVersionUID = -5705266650634591453L;
	
	/* automatically generated Logger */
	@SuppressWarnings("unused")
	private static final Logger LOGGER = Logger.getLogger(InvalidXMLContentException.class.getName());
	
	private String message="";
	
	public InvalidXMLContentException(String xmlErrors, Throwable cause) {
		super(xmlErrors,cause);
	}

	public InvalidXMLContentException(String xmlErrors) {
		super(xmlErrors);
	}

	/**
	 * @param string
	 * @param validationErrors
	 */
	public InvalidXMLContentException(String xmlErrors, List validationErrors) {
		super(xmlErrors);
		StringBuffer sb = new StringBuffer();
		Iterator iter = validationErrors.iterator();
		
		while (iter.hasNext()) {
			sb.append("[Validation-Error] " + iter.next() + "\n");
		}
		message= sb.toString();
	}
	
	@Override
	public String getMessage() {
		return super.getMessage()+ message;
	}

}
