/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml;

/**
 * contains constants for the EML plugin
 * 
 * @author Thomas Everding
 *
 */
public class Constants {
	
	/**
	 * SelectEvent function
	 */
	public static final String FUNC_SELECT_EVENT_NAME = "SelectEvent";
	
	/**
	 * SEelectproperty function
	 */
	public static final String FUNC_SELECT_PROPERTY_NAME = "SelectProperty";
	
	/**
	 * SelectSum function
	 */
	public static final String FUNC_SELECT_SUM_NAME = "SelectSum";
	
	/**
	 * SelectAvg function
	 */
	public static final String FUNC_SELECT_AVG_NAME = "SelectAvg";
	
	/**
	 * SelectMax function
	 */
	public static final String FUNC_SELECT_MAX_NAME = "SelectMax";
	
	/**
	 * SelectMin function
	 */
	public static final String FUNC_SELECT_MIN_NAME = "SelectMin";
	
	/**
	 * SelectCount function
	 */
	public static final String FUNC_SELECT_COUNT_NAME = "SelectCount";
	
	/**
	 * NotifyOnSelect function
	 */
	public static final String FUNC_NOTIFY_ON_SELECT_NAME = "NotifyOnSelect";
	
	/**
	 * SelectStdDev function (user defined)
	 */
	public static final String FUNC_SELECT_STDDEV_NAME = "SelectStdDev";
	
	/**
	 * select function parameter name for attribute eventName
	 */
	public static final String SELECT_PARAM_EVENT_NAME = "eventName";
	
	/**
	 * select function parameter name for attribute propertyName
	 */
	public static final String SELECT_PARAM_PROPERTY_NAME = "propertyName";
	
	/**
	 * select function parameter name for attribute Message
	 */
	public static final String SELECT_PARAM_MESSAGE_NAME = "message";
	
	/**
	 * length view name
	 */
	public static final String VIEW_LENGTH_NAME = "lengthView";
	
	/**
	 * time view name
	 */
	public static final String VIEW_TIME_NAME = "timeView";
	
	/**
	 * time length view name
	 */
	public static final String VIEW_TIME_LENGTH_NAME = "timeLengthView";
	
	/**
	 * all view name
	 */
	public static final String VIEW_ALL_NAME = "allView";
	
	/**
	 * view parameter for event count
	 */
	public static final String VIEW_PARAM_EVENT_COUNT_NAME = "EventCount";
	
	/**
	 * view parameter for duration
	 * (stored as long)
	 */
	public static final String VIEW_PARAM_DURATION_NAME = "Duration";
	
	/**
	 * cause operator
	 */
	public static final String OPERATOR_CAUSE_NAME = "cause";
	
	/**
	 * parallel operator
	 */
	public static final String OPERATOR_PARALLEL_NAME = "parallel";
	
	/**
	 * before operator
	 */
	public static final String OPERATOR_BEFORE_NAME = "before";
	
	/**
	 * and operator
	 */
	public static final String OPERATOR_AND_NAME = "and";
	
	/**
	 * and_not operator
	 */
	public static final String OPERATOR_AND_NOT_NAME = "and-not";
	
	/**
	 * or operator
	 */
	public static final String OPERATOR_OR_NAME = "or";
	
	/**
	 * esper EPL "where" - keyword
	 */
	public static final String EPL_WHERE = "where";
	
	/**
	 * esper EPL "select" - keyword
	 */
	public static final String EPL_SELECT = "select";
	
	/**
	 * esper EPL "from" - keyword
	 */
	public static final String EPL_FROM = "from";
	
	/**
	 * esper EPL "pattern" - keyword
	 */
	public static final String EPL_PATTERN = "pattern";
	
	/**
	 * esper EPL "insert" - keyword
	 */
	public static final String EPL_INSERT = "insert";
	
	/**
	 * esper EPL "into" - keyword
	 */
	public static final String EPL_INTO = "into";
	
	/**
	 * esper EPL part for the "at timer" 
	 */
	public static final String TIMER_AT = "timer:at";
	
	/**
	 * esper EPL part for the "interval timer"
	 */
	public static final String TIMER_INTERVAL = "timer:interval";
	
//	/**
//	 * event name prefix used to generate names for 
//	 * internally used timer events
//	 */
//	public static final String TIMER_INTERNAL_EVENT_PREFIX = "_internal_";
	
	/**
	 * value of events generated by timer patterns with SelectEvent
	 */
	public static final String TIMER_EVENT_VALUE = "TimerEvent";
	
	/**
	 * event name suffix used to generate names for
	 * result events of the counting statement of
	 * repetitive patterns.
	 */
	public static final String REPETIVITE_COUNT_EVENT_SUFFIX = "_count";
	
	/**
	 * namespace for custom comparison guards
	 */
	public static final String GUARD_COMPARISON_NAMESPACE = "comparison";
	
	/**
	 * namespace for custom logic guards
	 */
	public static final String GUARD_LOGIC_NAMESPACE = "logic";
}
