/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml;

/**
 * Interface for all classes able to handle outputs from EML processes (model or chain).
 * 
 * Implemented by {@link EMLProcessChain} and {@link EMLProcessExecutor}
 * 
 * @author Thomas Everding
 * 
 */
public interface IEMLProcessParent {
	
	/**
	 * Handles an output. The value is send to the receiver for the output. That can be another EML process (plugin
	 * internal output) or another plugin (external output).
	 * 
	 * @param outputName Name of the output (source name). Must be the full reference to the input or parameter
	 * (e.g. innerProcessname/outputs/output1). Base for the reference is this (the IEMLProcessParent).
	 * 
	 * @param value value to send
	 */
	public void handleOutput(String outputName, Object value);
}
