/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.esper;

import java.util.logging.Logger;

import com.espertech.esper.client.*;
import com.espertech.esper.event.EventBean;

/**
 * Statement aware update listener to debug the plugin
 * 
 * @author Thomas Everding
 *
 */
public class DebugListener implements StatementAwareUpdateListener{
	
	/*
	 * Logger instance for this class
	 */
	private Logger logger = Logger.getLogger(this.getClass().getName());

	public void update(EventBean[] newEvents, EventBean[] oldEvents, EPStatement epStatement, EPServiceProvider serviceProvider) {
		logger.fine("");
		logger.fine("-------------------------------");
		logger.fine("Update received for statement:");
		logger.fine("\tname: " + epStatement.getName());
		logger.fine("\ttext: " + epStatement.getText());
		
		if (newEvents != null) {
			logger.fine("new events:");
			logger.fine("\tsize: " + newEvents.length);
			
			for (int i = 0; i < newEvents.length; i++) {
				logger.fine("\tnumber " + i);
				logger.fine("\t\tbean:  " + newEvents[i]);
				
				try{
					Object obj = newEvents[i].get("value");
					logger.fine("\t\tvalue: " + obj);
				}
				catch (Throwable t) {}
			}
		}
		else {
			logger.fine("new events are null");
		}
		
		if (oldEvents != null) {
			logger.fine("old events:");
			logger.fine("\tsize: " + oldEvents.length);
			
			for (int i = 0; i < oldEvents.length; i++) {
				logger.fine("\tnumber " + i);
				logger.fine("\t\tbean: " + oldEvents[i]);
			}
		}
		else {
			logger.fine("old events are null");
		}
		
		logger.fine("service provider: ");
		logger.fine("\t" + serviceProvider);
		
		logger.fine("-------------------------------");
	}
	
}
