package de.ifgi.lehre.thesisEverding.eml.esper.customFunctions;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.io.*;


/**
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 */
public class SpatialMethods {


	public static boolean contains(Geometry geom, Geometry g) {
		return geom.contains(g);
	}

	public static boolean crosses(Geometry geom, Geometry g) {
		return geom.crosses(g);
	}

	public static boolean disjoint(Geometry geom, Geometry g) {
		return geom.disjoint(g);
	}
	
	public static boolean bbox(Geometry geom, Geometry g) {
		return !geom.disjoint(g);
	}

	public static boolean equals(Geometry geom, Geometry g) {
		return geom.equals(g);
	}

	public static boolean intersects(Geometry geom, Geometry g) {
		return geom.intersects(g);
	}

	public static boolean distanceWithin(Geometry geom, Geometry g, double distance) {
		return geom.isWithinDistance(g, distance);
	}
	
	public static boolean beyond(Geometry geom, Geometry g, double distance) {
		return !geom.isWithinDistance(g, distance);
	}

	public static boolean overlaps(Geometry geom, Geometry g) {
		return geom.overlaps(g);
	}

	public static boolean touches(Geometry geom, Geometry g) {
		return geom.touches(g);
	}

	public static boolean within(Geometry geom, Geometry g) {
		return geom.within(g);
	}

	public static Geometry fromWKT(String geomAsWkt) throws ParseException {
		WKTReader wktReader = new WKTReader(); //TODO: consider use of GeometryFactory
		return wktReader.read(geomAsWkt);
	}

	public static String toWKT(Geometry geom) throws ParseException {
		WKTWriter wktWriter = new WKTWriter(); //TODO: consider use of GeometryFactory
		return wktWriter.write(geom);
	}
}
