/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter;

/**
 * Standard methods for all filter elements
 * 
 * @author Thomas Everding
 * 
 */
public interface IFilterElement {
	
	/**
	 * Creates the esper String for this expression
	 * 
	 * @param complexPatternGuard if <code>true</code> the guard is used for a complex pattern, else for a simple
	 * pattern
	 * @return the esper string for this expression
	 */
	public String createExpressionString(boolean complexPatternGuard);

	public void setUsedProperty(String nodeValue);
	
}
