/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.comparison;

import java.util.HashSet;

import net.opengis.ogc.BinaryComparisonOpType;
import de.ifgi.lehre.thesisEverding.eml.filter.expression.AFilterExpression;

/**
 * superclass of all binary comparison filters
 * 
 * @author Thomas Everding
 *
 */
public abstract class ABinaryComparisonFilter extends AComparisonFilter {
	
	protected AFilterExpression first;
	
	protected AFilterExpression second;
	
	
	/**
	 * initializes the filter
	 * @param binaryOp
	 */
	protected void initialize(BinaryComparisonOpType binaryOp, HashSet<Object > propertyNames) {
		first  = AFilterExpression.FACTORY.buildFilterExpression(binaryOp.getExpressionArray(0), propertyNames, this);
		second = AFilterExpression.FACTORY.buildFilterExpression(binaryOp.getExpressionArray(1), propertyNames, this);
	}
	
}
