/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.comparison;

import java.util.HashSet;

import net.opengis.ogc.BinaryComparisonOpType;
import de.ifgi.lehre.thesisEverding.eml.esper.customFunctions.MethodNames;

/**
 * filters via >
 * 
 * @author Thomas Everding
 * 
 */
public class GreaterThanFilter extends ABinaryComparisonFilter {

	/**
	 * 
	 * Constructor
	 * 
	 * @param binaryOp
	 *            filter definition
	 */
	public GreaterThanFilter(BinaryComparisonOpType binaryOp,
			HashSet<Object> propertyNames) {
		this.initialize(binaryOp, propertyNames);
	}

	public String createExpressionString(boolean complexPatternGuard) {
		// if (complexPatternGuard) {
		// //build expression for complex patterns
		// // String result = Constants.GUARD_COMPARISON_NAMESPACE
		// // + ":greater("
		// // + this.first.createExpressionString(complexPatternGuard)
		// // + ", "
		// // + this.second.createExpressionString(complexPatternGuard)
		// // + ")";
		// String result = "("
		// + first.createExpressionString(complexPatternGuard)
		// + " > "
		// + second.createExpressionString(complexPatternGuard)
		// + ")";
		// return result;
		// }
		//		
		// //for simple patterns
		String result = "";

		if (first.getUsedProperty() != null || second.getUsedProperty() != null) {
			result += "(";

			boolean firstProperty = true;

			if (first.getUsedProperty() != null) {
				result += MethodNames.PROPERTY_EXISTS_NAME + "(this, \"" + first.getUsedProperty() + "\") ";
				firstProperty = false;
			}

			if (second.getUsedProperty() != null) {

				if (!firstProperty) {
					result += "AND ";
				}

				result += MethodNames.PROPERTY_EXISTS_NAME + "(this, \"" + second.getUsedProperty() + "\") ";
				firstProperty = false;
			}

			result += ") AND ";
		}
		result += "(" + first.createExpressionString(complexPatternGuard)
				+ " > " + second.createExpressionString(complexPatternGuard)
				+ ")";
		return result;
	}

}
