/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import java.util.HashSet;

import net.opengis.ogc.BinaryOperatorType;
import net.opengis.ogc.ExpressionType;


/**
 * Representation of a binary expression.
 * 
 * @author Thomas Everding
 * 
 */
public abstract class ABinaryFilterExpression extends AFilterExpression {
	
	protected AFilterExpression first;
	
	protected AFilterExpression second;
	
	
	
	
	/**
	 * initializes the expression
	 * 
	 * @param binaryOp
	 */
	protected void initialize(BinaryOperatorType binaryOp, HashSet<Object > propertyNames) {
		ExpressionType[] innerExpressions = binaryOp.getExpressionArray();
		
		this.first = FACTORY.buildFilterExpression(innerExpressions[0], propertyNames, this);
		this.second = FACTORY.buildFilterExpression(innerExpressions[1], propertyNames, this);
	}
}
