/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import net.opengis.ogc.ExpressionType;
import de.ifgi.lehre.thesisEverding.eml.filter.IFilterElement;

/**
 * represents a single ogc:expression
 * 
 * @author Thomas Everding
 *
 */
public abstract class AFilterExpression implements IFilterElement{
	
	/**
	 * Factory to build {@link AFilterExpression}s using a {@link ExpressionType}.
	 */
	public static final FilterExpressionFactory FACTORY = new FilterExpressionFactory();
	
	protected String usedProperty = null;

	public String getUsedProperty() {
		return usedProperty;
	}

	public void setUsedProperty(String usedProperty) {
		this.usedProperty = usedProperty;
	}
}
