/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import java.util.HashSet;

import net.opengis.ogc.BinaryOperatorType;

/**
 * Represents an expression for an addition
 * 
 * @author Thomas Everding
 *
 */
public class AddExpression extends ABinaryFilterExpression {
	
	/**
	 * 
	 * Constructor
	 *
	 * @param binaryOp definition of the expression
	 */
	public AddExpression(BinaryOperatorType binaryOp, HashSet<Object > propertyNames) {
		this.initialize(binaryOp, propertyNames);
	}


	public String createExpressionString(boolean complexPatternGuard) {
		String result = "("
						+ this.first.createExpressionString(complexPatternGuard)
						+ " + "
						+ this.second.createExpressionString(complexPatternGuard)
						+ ")";
		return result;
	}
	
}
