/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import java.util.HashSet;

import net.opengis.ogc.BinaryOperatorType;

/**
 * Represents an expression for a division
 * 
 * @author Thomas Everding
 *
 */
public class DivExpression extends ABinaryFilterExpression{
	
	
	/**
	 * 
	 * Constructor
	 *
	 * @param binaryOP definition of the expression
	 */
	public DivExpression(BinaryOperatorType binaryOP, HashSet<Object > propertyNames) {
		this.initialize(binaryOP, propertyNames);
	}
	

	public String createExpressionString(boolean complexPatternGuard) {
		String result = "("
						+ this.first.createExpressionString(complexPatternGuard)
						+ " / "
						+ this.second.createExpressionString(complexPatternGuard)
						+ ")";
		return result;
	}
	
}
