/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import net.opengis.gml.MeasureType;
import net.opengis.ogc.LiteralType;

/**
 * Represents an expression for a literal value 
 * 
 * @author Thomas Everding
 *
 */
public class LiteralExpression extends AFilterExpression{
	
	private LiteralType literal;
	private String literalString;
	
	/**
	 * 
	 * Constructor
	 *
	 * @param literal the literal value
	 */
	public LiteralExpression(LiteralType literal) {
		this.literal = literal;
		literalString = literal.newCursor().getTextValue();
	}

	public String createExpressionString(boolean complexPatternGuard) {
		if (complexPatternGuard) {
			//expression for complex patterns
			return "\"" + this.literalString + "\"";
		}
		
		//expression for simple patterns
		//TODO hier gml:Scalar parsen
		MeasureType q = literal.getQuantity();
		String s = q.getStringValue();
		return s;
	}
}
