/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import java.util.HashSet;

import net.opengis.ogc.BinaryOperatorType;

/**
 * Represents an expression for a multiplication 
 * 
 * @author Thomas Everding
 *
 */
public class MulExpression extends ABinaryFilterExpression{
	
	/**
	 * 
	 * Constructor
	 *
	 * @param binaryOp the expression definition
	 */
	public MulExpression(BinaryOperatorType binaryOp, HashSet<Object > propertyNames) {
		this.initialize(binaryOp, propertyNames);
	}

	public String createExpressionString(boolean complexPatternGuard) {
		String result = "("
						+ this.first.createExpressionString(complexPatternGuard)
						+ " * "
						+ this.second.createExpressionString(complexPatternGuard)
						+ ")";
		return result;
	}
	
}
