/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.filter.expression;

import java.util.HashSet;

import net.opengis.ogc.PropertyNameType;


/**
 * Represents an expression for a property name
 * 
 * @author Thomas Everding
 * 
 */
public class PropertyNameExpression extends AFilterExpression {
	
	private String propertyName;
	
	
	/**
	 * 
	 * Constructor
	 * 
	 * @param propName name of a property
	 */
	public PropertyNameExpression(PropertyNameType propName, HashSet<Object> propertyNames) {
		String name = propName.getDomNode().getFirstChild().getNodeValue();
		//replaceAll(":", "__")
		this.propertyName = name.replaceAll("/", ".");
		
		if (!propertyNames.contains(propertyName)) {
			propertyNames.add(propertyName);
		}
	}
	

	public String createExpressionString(boolean complexPatternGuard) {
		if (complexPatternGuard) {
			String result = this.propertyName;//.replaceAll("\\.", ":");
			return result;
		}
		
		//remove event name part
		int i;
		if (((i = this.propertyName.indexOf(".")) > 0)) {
			return this.propertyName.substring(i + 1);
		}
		
		return this.propertyName;
	}
	
}
