/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */


package de.ifgi.lehre.thesisEverding.eml.filter.logic;

import java.util.HashSet;
import java.util.logging.Logger;

import net.opengis.ogc.UnaryLogicOpType;
import de.ifgi.lehre.thesisEverding.eml.filter.IFilterElement;
import de.ifgi.lehre.thesisEverding.eml.filter.comparison.AComparisonFilter;

/**
 * Representation of not filters.
 * 
 * @author Thomas Everding
 *
 */
public class NotFilter extends ALogicFilter{
	
	/*
	 * Logger instance for this class
	 */
	private Logger logger = Logger.getLogger(this.getClass().getName());
	
	private IFilterElement element;
	
	
	/**
	 * 
	 * Constructor
	 *
	 * @param unaryOp filter definition
	 */
	public NotFilter(UnaryLogicOpType unaryOp, HashSet<Object > propertyNames) {
		if (unaryOp.isSetComparisonOps()) {
			//element is comparison operator
			element = AComparisonFilter.FACTORY.buildComparisonFilter(unaryOp.getComparisonOps(), propertyNames);
		}
		else if (unaryOp.isSetLogicOps()) {
			//element is logical operator
			element = ALogicFilter.FACTORY.buildLogicFilter(unaryOp.getLogicOps(), propertyNames);
		}
		else {
			//not supported
			logger.severe("the operator type is not supported");
		}
	}


	public String createExpressionString(boolean complexPatternGuard) {
		String result = "( not "
						+ this.element.createExpressionString(complexPatternGuard)
						+ ")";
		return result;
	}
}
