package de.ifgi.lehre.thesisEverding.eml.filter.spatial;

import net.opengis.ogc.BinarySpatialOpType;

import com.vividsolutions.jts.geom.Geometry;

import de.ifgi.lehre.thesisEverding.eml.esper.customFunctions.MethodNames;
import de.ifgi.lehre.thesisEverding.eml.event.MapEvent;

/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public abstract class ABinarySpatialFilter extends ASpatialFilter {
	
	protected BinarySpatialOpType bsOperator;

	public ABinarySpatialFilter(BinarySpatialOpType bsOp) {
		this.bsOperator = bsOp;
	}
	
	protected String createExpressionForBinaryFilter(String methodName, Geometry geom) {
		StringBuilder sb = new StringBuilder();
		
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		sb.append(methodName+ "(");
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		//create WKT from corners
		sb.append("fromWKT(\""+ geom.toText() +"\")");
		sb.append(", ");
		sb.append(MapEvent.GEOMETRY_KEY +")");
		
		return sb.toString();
	}

}
