package de.ifgi.lehre.thesisEverding.eml.filter.spatial;

import javax.xml.namespace.QName;

import net.opengis.gml.PointType;
import net.opengis.ogc.DistanceBufferType;

import org.apache.muse.util.xml.XmlUtils;
import org.w3c.dom.Element;

import com.vividsolutions.jts.geom.Geometry;

import de.ifgi.lehre.thesisEverding.eml.esper.customFunctions.MethodNames;
import de.ifgi.lehre.thesisEverding.eml.event.MapEvent;

/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public abstract class ADistanceBufferFilter extends ASpatialFilter {

	protected static final QName POINT_QNAME = new QName("http://www.opengis.net/gml", "Point");
	
	protected static final QName LINEAR_RING_QNAME = new QName("http://www.opengis.net/gml", "LinearRing");
	
	protected DistanceBufferType dbOperator;

	public ADistanceBufferFilter(DistanceBufferType dbOp) {
		this.dbOperator = dbOp;
	}
	
	protected String createExpressionForDistanceFilter(String methodName) {
		//TODO unit conversion?
		//String uom = dbOperator.getDistance().getUnits();

		Element elem = (Element) dbOperator.getDistance().getDomNode();
		String val = XmlUtils.toString(elem.getFirstChild());
		double distance = Double.parseDouble(val);
		
		QName geomName = dbOperator.getGeometry().newCursor().getName();
		
		Geometry geom = null;
		if (LINEAR_RING_QNAME.equals(geomName)) {
			//TODO parse linear ring
		}
		
		else if (POINT_QNAME.equals(geomName)) {
			PointType pt = (PointType) dbOperator.getGeometry();
			geom = getGeometryFromPoint(pt);
		}
		
		if (geom == null) {
			return null;
		}
		
		StringBuilder sb = new StringBuilder();
		
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		sb.append(methodName+ "(");
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		//create WKT from corners
		sb.append("fromWKT(\""+ geom.toText() +"\")");
		sb.append(", ");
		sb.append(MapEvent.GEOMETRY_KEY +", ");
		sb.append(distance +")");
		
		return sb.toString();
	}

}
