package de.ifgi.lehre.thesisEverding.eml.filter.spatial;

import net.opengis.ogc.BBOXType;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.io.ParseException;

import de.ifgi.lehre.thesisEverding.eml.esper.customFunctions.MethodNames;
import de.ifgi.lehre.thesisEverding.eml.event.MapEvent;

/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public class BBOXFilter extends ASpatialFilter {

	private BBOXType bboxOperator;

	public BBOXFilter(BBOXType bboxOp) {
		this.bboxOperator = bboxOp;
	}

	public String createExpressionString(boolean complexPatternGuard) {
		Geometry geom = null;
		try {
			geom = getGeometryFromEnvelope(bboxOperator.getEnvelope());
		} catch (ParseException e) {
			e.printStackTrace();
		}
		
		StringBuilder sb = new StringBuilder();
		
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		sb.append("bbox(");
		sb.append(MethodNames.SPATIAL_METHODS_PREFIX);
		//create WKT from corners
		sb.append("fromWKT(\""+ geom.toText() +"\")");
		sb.append(", ");
		sb.append(MapEvent.GEOMETRY_KEY +")");
		
		return sb.toString();
	}

	public void setUsedProperty(String nodeValue) {
	}

}
