/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.pattern;

import java.util.HashSet;
import java.util.Vector;

import de.ifgi.lehre.thesisEverding.eml.esper.EMLParser;

/**
 * superclass of all patterns
 * 
 * @author Thomas Everding
 *
 */
public abstract class APattern{
	
	protected String patternID;
	
	protected String description = "";
	
	protected Vector<SelFunction> selectFunctions = new Vector<SelFunction>();
	
	protected HashSet<Object> propertyNames = new HashSet<Object>();

	/**
	 * @return the patternID
	 */
	public String getPatternID() {
		return this.patternID;
	}

	/**
	 * sets the patternID
	 * 
	 * @param patternID the patternID to set
	 */
	public void setPatternID(String patternID) {
		this.patternID = patternID;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return this.description;
	}

	/**
	 * sets the pattern description
	 * 
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the select functions
	 */
	public Vector<SelFunction> getSelectFunctions() {
		return this.selectFunctions;
	}
	
	
	/**
	 * adds a select function
	 * 
	 * @param selectFunction the new select function
	 */
	public void addSelectFunction(SelFunction selectFunction) {
		this.selectFunctions.add(selectFunction);
	}
	
	
	/**
	 * creates an esper EPL statement
	 * 
	 * @return this pattern in esper EPL, one statement for every select clause
	 */
	public abstract Statement[] createEsperStatements();

	public abstract Statement[] createEsperStatements(EMLParser parser);
	
	public HashSet<Object> getPropertyNames() {
		return propertyNames;
	}
	
}
