/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.eml.pattern;

import java.util.HashSet;

import net.opengis.ogc.FilterType;
import de.ifgi.lehre.thesisEverding.eml.Constants;
import de.ifgi.lehre.thesisEverding.eml.esper.customFunctions.MethodNames;
import de.ifgi.lehre.thesisEverding.eml.filter.StatementFilter;

/**
 * representation of a guard
 * 
 * @author Thomas Everding
 *
 */
public class PatternGuard {
	
	private StatementFilter filter;
	
	private String statement = "";

//	private long maxListeningDuration = -1;

	/**
	 * @param filter the filter to set
	 */
	public void setFilter(FilterType filter, HashSet<Object > propertyNames) {
		this.filter = new StatementFilter(filter, propertyNames);
	}
	
	
	/**
	 * creates the esper statement for this guard
	 * @param complexPatternGuard if <code>true</code> the property names are used with the event names, else only the
	 * property names are used
	 * 
	 * @return the guard as esper where clause
	 */
	public String createStatement(boolean complexPatternGuard, String propertyName) {
		if (!this.statement.equals("")) {
			//statement already created
			return this.statement;
		}
		
//		if (complexPatternGuard) {
//			//create statement for complex patterns
//			this.statement += Constants.EPL_WHERE 
//							  + " "
//							  + this.filter.createExpressionString(complexPatternGuard);
//			
//			return this.statement;
//		}
		
		//create statement for simple patterns
		this.statement = Constants.EPL_WHERE
						 + " ";
		
		if (propertyName != null) {
			this.statement += "(" + MethodNames.PROPERTY_EXISTS_NAME + "(" + propertyName + ")) AND "; 
		}
		
		this.statement += this.filter.createExpressionString(complexPatternGuard);
		
		return this.statement;
	}


//	/**
//	 * sets the max Listening Duration
//	 * @param maxListeningDuration maximum duration for listening
//	 */
//	public void setMaxListeningDuration(long maxListeningDuration) {
//		this.maxListeningDuration = maxListeningDuration;
//	}
	
}
