/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.process;

/**
 * abstract description of a connection (in- or output)
 * @author Thomas Everding
 *
 */
public abstract interface IConnectionDescription {
	
	/**
	 * 
	 * @return the name of the connection
	 */
	public String getName();
	
	
	/**
	 * sets the name of the connection
	 * 
	 * @param name the name
	 */
	public void setName(String name);
	
	
	/**
	 * 
	 * @return the unit of measurement of the connection
	 */
	public String getUOM();
	
	
	/**
	 * sets the unit of measurement of the connection
	 * 
	 * @param uom the unit of measurement
	 */
	public void setUOM(String uom);
	
	
	/**
	 * 
	 * @return the data type of the connection
	 */
	public String getDataType();
	
	
	/**
	 * sets the data type of the connection
	 * 
	 * @param type data type as String
	 */
	public void setDataType(String type);
}
