/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.process;

import net.opengis.sensorML.x101.IoComponentPropertyType;
import net.opengis.swe.x101.DataComponentPropertyType;



/**
 * Description of a single process input
 * 
 * @author Thomas Everding
 *
 */
public class InputDescription implements IConnectionDescription{
	
	private String name = "";
	private String uom = "";
	private String dataType = "";
	private boolean inUse = false;
	
	private IoComponentPropertyType inputUnderlying = null;;
	private DataComponentPropertyType paramUnderlying = null;


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getUOM() {
		return uom;
	}


	public void setUOM(String uom) {
		this.uom = uom;
	}


	public String getDataType() {
		return dataType;
	}


	public void setDataType(String type) {
		this.dataType = type;
	}
	
	
	/**
	 * 
	 * @return <code>true</code> if the connection is in use
	 */
	public boolean isInUse() {
		return inUse;
	}


	/**
	 * sets if the connection is in use
	 * 
	 * @param inUse <code>true</code> if the connection is in use
	 */
	public void setInUse(boolean inUse) {
		this.inUse = inUse;
	}


	/**
	 * @return the inputUnderlying
	 */
	public IoComponentPropertyType getInputUnderlying() {
		return this.inputUnderlying;
	}


	/**
	 * @param inputUnderlying the inputUnderlying to set
	 */
	public void setInputUnderlying(IoComponentPropertyType inputUnderlying) {
		this.inputUnderlying = inputUnderlying;
	}


	/**
	 * @return the paramUnderlying
	 */
	public DataComponentPropertyType getParamUnderlying() {
		return this.paramUnderlying;
	}


	/**
	 * @param paramUnderlying the paramUnderlying to set
	 */
	public void setParamUnderlying(DataComponentPropertyType paramUnderlying) {
		this.paramUnderlying = paramUnderlying;
	}
	
}
