/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.processCommunication;

import de.ifgi.lehre.thesisEverding.processCommunication.fifoQueue.FIFOQueue;

/**
 * Connector to an environment-internal
 * data stream.
 * 
 * @author Thomas Everding
 *
 */
public class InternalStreamConnector extends ADataConnector{
	
	private FIFOQueue fifoQueue;
	
	
	/**
	 * 
	 * Constructor
	 *
	 * @param fifoQueue connection to an internal process
	 */
	public InternalStreamConnector(FIFOQueue fifoQueue) {
		this.fifoQueue = fifoQueue;
	}


	@Override
	/**
	 * reads an item from a data connection
	 * (input)
	 * 
	 * @return a new item
	 */
	public Object read() {
		return fifoQueue.getItem();
	}


	@Override
	/**
	 * writes an item to the data connection
	 * 
	 * @param item the item to write
	 */
	public void write(Object item) {
		fifoQueue.addItem(item);
	}
}
