/**
 * Part of the diploma thesis of Thomas Everding.
 * @author Thomas Everding
 */

package de.ifgi.lehre.thesisEverding.processCommunication.fifoQueue;

/**
 * A single element in the {@link FIFOQueue}
 * 
 * @author Thomas Everding
 * 
 */
public class FIFOQueueElement {
	
	private FIFOQueueElement next = null;
	
	private Object item;
	
	
	/**
	 * 
	 * Constructor
	 * 
	 * @param item item encapsulated by this queue element
	 */
	public FIFOQueueElement(Object item) {
		this.item = item;
	}
	

	/**
	 * 
	 * @return the next queue element
	 */
	public FIFOQueueElement getNext() {
		return this.next;
	}
	

	/**
	 * sets a following queue element
	 * 
	 * @param next the next element
	 */
	public void setNext(FIFOQueueElement next) {
		this.next = next;
	}
	

	/**
	 * 
	 * @return the item encapsulated by this queue element
	 */
	public Object getItem() {
		return this.item;
	}
	
}
