package org.n52.swe.sas.muse.filter;

import javax.xml.namespace.QName;

import net.opengis.eml.x001.EMLDocument;
import net.opengis.ogc.FilterDocument;

import org.apache.muse.util.xml.XmlUtils;
import org.apache.muse.ws.notification.Filter;
import org.apache.muse.ws.notification.faults.InvalidFilterFault;
import org.apache.muse.ws.notification.impl.FilterFactoryHandler;
import org.apache.muse.ws.resource.basefaults.BaseFault;
import org.apache.xmlbeans.XmlException;
import org.apache.xmlbeans.XmlObject;
import org.w3c.dom.Element;

/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public class SESConstraintFilterHandler implements FilterFactoryHandler {

	public boolean accepts(QName filterName, String filterDialect ) {
		//check against the Dialect. TODO is this enough?
		if (filterDialect.equals("http://52north.org/ses/contentfilter")) {
			return true;
		}
		return false;
	}

	public Filter newInstance(Element filterXml) throws BaseFault {
		
		XmlObject obj = null;
		try {
			Element elem = null;
			QName qnEml = new QName("http://www.opengis.net/eml/0.0.1", "EML");
			elem = XmlUtils.getElement(filterXml, qnEml);
			if (elem != null) {
				//return a new SESConstraintFilter with EML
				obj = EMLDocument.Factory.parse(elem);
				return new SESConstraintFilter((EMLDocument) obj);
			} else {
				QName qnFilter = new QName("http://www.opengis.net/ogc", "Filter");
				elem = XmlUtils.getElement(filterXml, qnFilter);
				if (elem != null) {
					//return a new SESConstraintFilter with FilterDocument
					obj = FilterDocument.Factory.parse(elem);
					return new SESConstraintFilter((FilterDocument) obj);
				}
			}
		} catch (XmlException e) {
			throw new InvalidFilterFault(e);
		}
		
		throw new InvalidFilterFault("Either an ogc:Filter or EML is needed.");
		
	}

}
