package org.n52.swe.sas.muse.filter;

import java.math.BigInteger;

import net.opengis.eml.x001.*;
import net.opengis.eml.x001.EMLDocument.EML;
import net.opengis.eml.x001.EMLDocument.EML.SimplePatterns;
import net.opengis.eml.x001.ViewType.LengthView;
import net.opengis.ogc.FilterType;


/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public class StaticEMLDocument {
	
	/**
	 * Generates a simple EML type holding one
	 * simple pattern with the given FilterType.
	 */
	public static EML getWrapperDocument(FilterType ogcFilter) {
		EML eml = EML.Factory.newInstance();
		
		eml.addNewComplexPatterns();
		eml.addNewRepetitivePatterns();
		eml.addNewTimerPatterns();
		
		SimplePatterns simple = eml.addNewSimplePatterns();
		
		SimplePatternType pattern = simple.addNewSimplePattern();
		
		pattern.setPatternID("defaultSimplePattern");
		pattern.setInputName("sensorStream");
		
		pattern.addNewSelectFunctions();
		
		ViewType view = pattern.addNewView();
		LengthView length = view.addNewLengthView();
		length.setEventCount(new BigInteger("1"));
		
		GuardType guard = pattern.addNewGuard();
		guard.setFilter(ogcFilter);
		
		pattern.addNewPropertyRestrictions();
		
		return eml;
	}

}
