package org.n52.swe.sas.muse.filter.engine;

import java.util.Map;

import org.apache.muse.ws.addressing.soap.SoapFault;
import org.apache.muse.ws.notification.NotificationMessage;
import org.apache.muse.ws.notification.SubscriptionManager;

import com.espertech.esper.client.UpdateListener;
import com.espertech.esper.event.EventBean;

import de.ifgi.lehre.thesisEverding.eml.event.MapEvent;

/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public class BasicListener implements UpdateListener {
	
    private SubscriptionManager subMgr;

	public BasicListener(SubscriptionManager subMgr) {
    	this.subMgr = subMgr;
	}

	@SuppressWarnings("unchecked")
	public void update(EventBean[] newEvents, EventBean[] oldEvents) {
        EventBean event = newEvents[0];
        Map alert = (Map) event.getUnderlying();
        try {
        	//get message and forward to SESSubscriptionManager
        	NotificationMessage message = (NotificationMessage) alert.get(MapEvent.ORIGNIAL_MESSAGE_KEY);
			subMgr.publish(message);
		} catch (SoapFault e) {
			e.printStackTrace();
		}
    }
    
}
