// 
// MyCapability.java
// Wed May 21 15:24:25 CEST 2008
// Generated by the Apache Muse Code Generation Tool
// 
package org.n52.swe.sas.muse.wsbr;

import java.lang.reflect.Method;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.namespace.QName;

import org.apache.muse.core.*;
import org.apache.muse.core.routing.MessageHandler;
import org.apache.muse.util.ReflectUtils;
import org.apache.muse.ws.addressing.EndpointReference;
import org.apache.muse.ws.addressing.soap.SoapFault;
import org.apache.muse.ws.resource.WsResource;
import org.apache.muse.ws.resource.impl.AbstractWsResourceCapability;
import org.apache.muse.ws.resource.lifetime.ScheduledTermination;
import org.n52.swe.sas.muse.wsbr.soaphandler.PublisherHandler;


/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 * 
 * Handles the creation of new {@link PublisherEndpoint} resources.
 */
public class RegisterPublisher extends AbstractWsResourceCapability implements IRegisterPublisher, ResourceManagerListener {
	/* automatically generated Logger */@SuppressWarnings("unused")
	private static final Logger LOGGER = Logger.getLogger(RegisterPublisher.class.getName());

	private ConcurrentHashMap<EndpointReference, PublisherEndpoint> map = new ConcurrentHashMap<EndpointReference, PublisherEndpoint>();
	public final static String resourceType = "RegisterPublisherContextPath";
	private String registerPath;


	QName[] PROPERTIES = new QName[] {};

	private String publisherRegistrationManagerEndpoint;

	private ResourceManager manager;

	public RegisterPublisher() {

	}

	@Override
	public void initialize() throws SoapFault {
		super.initialize();

		/* get the Manager instance */
		WsResource resource = getWsResource();
		manager = resource.getResourceManager();

		/*
		 * select the register method that is called on "register" by the
		 * Publisher message handler
		 */
		setMessageHandler(createrRegisterPublisherHandler());

		//
		// make sure we're exposing the advertise endpoint so that
		// clients can manage subscriptions/consumers
		//
		registerPath = manager.getResourceContextPath(RegisterPublisher.class);
		if (registerPath == null) {
			throw new RuntimeException("NoRegisterPublisher");
		}

		/* retrieve the PublicationEndpoint context path */
		publisherRegistrationManagerEndpoint = manager.getResourceContextPath(PublisherEndpoint.class);

		if (publisherRegistrationManagerEndpoint == null) {
			throw new RuntimeException("No PublicationEndpoint deployed");
		}

		/* add ourselves as listener for shutdown of PRM instances */
		manager.addListener(this);

	}

	@Override
	public void initializeCompleted() throws SoapFault {
		super.initializeCompleted();
	}

	/**
	 * Sets the Handler for incoming SOAP requests
	 * 
	 * @return a new {@link PublisherHandler} instance
	 */
	private MessageHandler createrRegisterPublisherHandler() {

		MessageHandler handler = new PublisherHandler();
		Method method = ReflectUtils.getFirstMethod(getClass(), "registerPublisher");
		handler.setMethod(method);

		return handler;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.n52.swe.sas.muse.wsbr.IRegisterPublisher#registerPublisher(org.apache.muse.ws.addressing.EndpointReference,
	 *      org.w3c.dom.Element[], boolean, java.util.Date)
	 * 
	 * This method is called for incomming SOAP requests. Messages are extracted
	 * by the PublisherHander. The response is rendered by the PublisherHandler,
	 * too.
	 */
	public Resource registerPublisher(EndpointReference publisherReference, QName[] topic, boolean demand, Date initialTerminationTime, org.w3c.dom.Element sensorML) throws Exception {
		Resource publisherResource = null;
		try {
			/* create new resource (@see SimpleNotificationProducer) */
			publisherResource = manager.createResource(publisherRegistrationManagerEndpoint);
			EndpointReference epr = publisherResource.getEndpointReference();
			PublisherEndpoint publisherCapability = (PublisherEndpoint) publisherResource.getCapability(IPublisherEndpoint.NAMESPACE_URI);
			map.put(epr, publisherCapability);

			/* set topics */
			publisherCapability.setTopic(topic);
			publisherCapability.setSensorML(sensorML);
			
			/*
			 * set termination time
			 * @see SimpleScheduledTermination
			 */
			ScheduledTermination scheduledTermination = (ScheduledTermination) publisherResource
					.getCapability("http://docs.oasis-open.org/wsrf/rlw-2/ScheduledResourceTermination");
			scheduledTermination.setTerminationTime(generateTerminationTime(initialTerminationTime));

			/* don't change the EPR after the following step */
			publisherResource.initialize();
			manager.addResource(epr, publisherResource);

		} catch (Throwable error) {
			LOGGER.log(Level.WARNING, "couldn't create new PublicationEndpoint", error);
		}

		return publisherResource;
	}

	/**
	 * calculates a valid termination time.
	 * 
	 * @param initialTerminationTime
	 * @return
	 */
	protected Date generateTerminationTime(Date initialTerminationTime) {
		Date now = new Date();
		if (initialTerminationTime != null && initialTerminationTime.after(now)) {
			return initialTerminationTime;
		} else {
			/* complicated java date handling ... */
			Calendar cal = new GregorianCalendar();
			cal.add(Calendar.DAY_OF_YEAR, 1);
			return cal.getTime();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.muse.core.ResourceManagerListener#resourceAdded(org.apache.muse.ws.addressing.EndpointReference,
	 *      org.apache.muse.core.Resource)
	 */
	public void resourceAdded(EndpointReference epr, Resource resource) throws SoapFault {
		/* no action needed, yet */
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.muse.core.ResourceManagerListener#resourceRemoved(org.apache.muse.ws.addressing.EndpointReference)
	 */
	public void resourceRemoved(EndpointReference epr) throws SoapFault {
		if (epr != null) {
			Object isInMap = map.remove(epr);
			if(isInMap instanceof PublisherEndpoint) {
				LOGGER.info("The PublisherEndpoint " + isInMap.toString() + " has been removed.");
			}
		} else {
			LOGGER.fine("Attemp to remove a null value from PublisherEnpoint map");
		}
	}

	/**
	 * @return all {@link PublisherEndpoint} instances that have been created by
	 *         this instance
	 */
	public Collection<PublisherEndpoint> getPublisherEndpoints() {
		return map.values();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.muse.ws.resource.impl.AbstractWsResourceCapability#getPropertyNames()
	 */
	@Override
	public QName[] getPropertyNames() {
		return PROPERTIES;
	}

}