/***************************************************************
Copyright 2007 52North Initiative for Geospatial Open Source Software GmbH

 Author: jtheuer, University of Muenster

 Contact: Andreas Wytzisk, 
 52North Initiative for Geospatial Open Source SoftwareGmbH, 
 Martin-Luther-King-Weg 24,
 48155 Muenster, Germany, 
 info@52north.org

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 version 2 as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; even without the implied WARRANTY OF
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program (see gnu-gpl v2.txt). If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA or visit the Free
 Software Foundations web page, http://www.fsf.org.

 ***************************************************************/

package org.n52.swe.sas.muse.wsbr;

import javax.xml.namespace.QName;

/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 * 
 */
public interface WsbrConstants {
	public static final String NAMESPACE_URI = "http://docs.oasis-open.org/wsn/br-2";

	public static final String PREFIX = "wsnt";

	public static final QName CREATION_QNAME = new QName(NAMESPACE_URI, "CreationTime", PREFIX);

	//public static final QName CURRENT_TIME_QNAME = new QName(NAMESPACE_URI, "CurrentTime", PREFIX);

	public static final String PUBLISHER_REFERENCE_URI = NAMESPACE_URI+"/PublisherReference";
	public static final QName PUBLISHER_REFERENCE_QNAME = new QName(NAMESPACE_URI, "PublisherReference", PREFIX);
	
	public static final QName DEMAND = new QName(NAMESPACE_URI, "Demand", PREFIX);
	
	public static final QName TOPIC = new QName(NAMESPACE_URI, "Topic", PREFIX);

	public static final QName REGISTER_PUBLISHER = new QName(NAMESPACE_URI,"RegisterPublisher");
	
	public static final String REGISTER_PUBLISHER_URI = NAMESPACE_URI + "/RegisterPublisher";

	public static final String PUBLISHER_ENDPOINT_URI = NAMESPACE_URI+"/PublisherEndpoint";
	
	public static final QName PUBLISHER_REGISTRATION_REFERENCE = new QName(NAMESPACE_URI,"PublisherRegistrationReference");
	
	public static final QName CONSUMER_REFERENCE_QNAME = new QName(NAMESPACE_URI,"ConsumerReference");
}
