package org.n52.swe.sas.muse.wsn;

import javax.xml.namespace.QName;

import org.apache.muse.ws.addressing.soap.SoapFault;
import org.apache.muse.ws.notification.NotificationMessage;
import org.apache.muse.ws.notification.NotificationMessageListener;
import org.w3c.dom.Element;


/**
 * 
 * @author Matthes Rieke <m.rieke@uni-muenster.de>
 *
 */
public class SESMessageListener implements NotificationMessageListener {
	
	private SESNotificationProducer producer;

	public SESMessageListener(SESNotificationProducer np) {
		producer = np;
	}

	public boolean accepts(NotificationMessage message) {
		/*
		 * TODO check against ProducerReferences?
		 * message.getProducerReference(); ?
		 */
		
		return true;
	}

	public void process(NotificationMessage message) throws SoapFault {
		/*
		 * forward message to NotificationProducer
		 */
		
		/*
		 * currently only O&M Observation is supported
		 */
		
		QName omQName = new QName("http://www.opengis.net/om/1.0", "Observation");
		Element content = message.getMessageContent(omQName);
		
		if (content != null) {
			producer.publish(message.getTopic(), content);	
		}
		
	}

}
