package org.n52.swe.sas.muse;

import java.io.*;
import java.net.*;
import java.util.HashMap;

import org.apache.muse.core.AbstractEnvironment;
import org.apache.muse.util.messages.Messages;
import org.apache.muse.util.messages.MessagesFactory;
import org.apache.muse.ws.addressing.EndpointReference;
import org.apache.muse.ws.addressing.soap.SoapClient;
import org.w3c.dom.Document;

import sun.net.www.protocol.http.HttpURLConnection;

public class InlineEnvironment extends AbstractEnvironment {

	SoapClient client = null;
	
	public InlineEnvironment(InlineIsolationLayer layer){
		setDefaultURI("inline://"+"tests"+"/");
		client = new InlineSoapClient(this, layer);
    }
	
	private static Messages _MESSAGES = MessagesFactory.get(AbstractEnvironment.class);
    
	private HashMap<String, Document> cache = new HashMap<String, Document>();
	
    public EndpointReference getDeploymentEPR()
    {
        String defaultString = getDefaultURI();
        URI defaultURI = URI.create(defaultString);
        return new EndpointReference(defaultURI);
    }

	public File getRealDirectory() {
		/* this "hack" only works in file-system based environments! */
		/* we look for the muse.xml to get the correct filename location */
		File musexml = new File(getClass().getResource("/muse.xml").getFile());
		return musexml.getParentFile();
	}

	@Override
	public SoapClient getSoapClient() {
    	return client;
    }

	@Override
	public InputStream getDataResourceStream(String path) {
		try {
			return super.getDataResourceStream(path);
		} catch (RuntimeException e) {
			try {
				/* first, look in cache */
				String encodedpath = path.replace("/", "_");
				File dir = new File(System.getProperty("user.home") + "/.sescache/");
				dir.mkdir();
				
				File f = new File(System.getProperty("user.home") + "/.sescache/"+encodedpath);
				
				if(f.exists()) {
					System.out.println("cache hit: " + path);
					return new FileInputStream(f);
				} else {
					System.out.println("reading url: " + path);
					URL url = new URL(path);
					HttpURLConnection c = new HttpURLConnection(url,null);
					FileOutputStream fout = new FileOutputStream(f);
					org.apache.commons.io.IOUtils.copy(c.getInputStream(), fout);
					return new FileInputStream(f);
				}
			} catch (MalformedURLException e1) {
				throw new RuntimeException("cannot get resource: " + path);
			} catch (IOException e2) {
				throw new RuntimeException("io error while reading: " + path,e);
			}
			
		}
	}

//	@Override
//	public Document getDocument(String path) {
//		Document doc = cache.get(path);
//		if(doc == null) {
//			doc = super.getDocument(path);
//			cache.put(path, doc);
//		}
//		return doc;
//	}
    
	
}
