/***************************************************************
Copyright 2007 52North Initiative for Geospatial Open Source Software GmbH

 Author: jtheuer, University of Muenster

 Contact: Andreas Wytzisk, 
 52North Initiative for Geospatial Open Source SoftwareGmbH, 
 Martin-Luther-King-Weg 24,
 48155 Muenster, Germany, 
 info@52north.org

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 version 2 as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; even without the implied WARRANTY OF
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program (see gnu-gpl v2.txt). If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA or visit the Free
 Software Foundations web page, http://www.fsf.org.

 ***************************************************************/

	
package org.n52.swe.sas.muse.common;
import java.io.IOException;
import java.util.logging.Logger;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.muse.util.xml.XmlUtils;
import org.n52.swe.sas.bindings.InvalidXMLContentException;
import org.n52.swe.sas.muse.MuseTestCase;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 * Test for {@link Capabilites}
 */
public class TestCommon extends MuseTestCase {

	/* automatically generated Logger */@SuppressWarnings("unused")
	private static final Logger LOGGER = Logger.getLogger(TestCommon.class.getName());
	
	/**
	 * @param name
	 */
	public TestCommon(String name) {
		super(name);
		
	}

	/* (non-Javadoc)
	 * @see org.n52.swe.sas.muse.MuseTestCase#setUp()
	 */
	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}
	
	public final void testCapabilites() throws SAXException, IOException, ParserConfigurationException, InvalidXMLContentException {
		Document dom = readResourceAsDom("/testCapabilities.xml");
		iso.handleRequest(dom);

		/* add a sensor */
		iso.handleRequest(readResourceAsDom("/testRegisterPublisher.xml"));
		Document dom2 = readResourceAsDom("/testCapabilities.xml");
		Document doc2 = iso.handleRequest(dom2);
		assertTrue(XmlUtils.toString(doc2).contains("urn:ogc:object:feature:Sensor:IFGI:dummysensor1"));

		/* add another sensor */
		iso.handleRequest(readResourceAsDom("/testRegisterPublisher.xml"));
		Document dom3 = readResourceAsDom("/testCapabilities.xml");
		Document doc3 = iso.handleRequest(dom3);
		LOGGER.info(XmlUtils.toString(doc3));
	}
	
	public final void testDescribeSensor() throws SAXException, IOException, ParserConfigurationException {
		
		/* add a sensor */
		iso.handleRequest(readResourceAsDom("/testRegisterPublisher.xml"));

		/* request SensorML */
		Document dom = readResourceAsDom("/testDescribeSensor.xml");
		Document doc3 = iso.handleRequest(dom);
		LOGGER.info(XmlUtils.toString(doc3));
	}
}
