/***************************************************************
Copyright 2007 52North Initiative for Geospatial Open Source Software GmbH

 Author: jtheuer, University of Muenster

 Contact: Andreas Wytzisk, 
 52North Initiative for Geospatial Open Source SoftwareGmbH, 
 Martin-Luther-King-Weg 24,
 48155 Muenster, Germany, 
 info@52north.org

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 version 2 as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; even without the implied WARRANTY OF
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program (see gnu-gpl v2.txt). If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA or visit the Free
 Software Foundations web page, http://www.fsf.org.

 ***************************************************************/

	
package org.n52.swe.sas.muse.soapclient;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.logging.*;

/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 *
 */
public class SesClient {
	/* automatically generated Logger */@SuppressWarnings("unused")
	private static final Logger LOGGER = Logger.getLogger(SesClient.class.getName());

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		SoapClient client = new SoapClient(new URL("http://ruth0.uni-muenster.de:8180/sas-muse-3.0-SNAPSHOT/"));
		//SoapClient client = new SoapClient(new URL("http://v-tml.uni-muenster.de:8080/sas-muse-3.0-SNAPSHOT/services"));
		InputStream input_cap = client.getClass().getResourceAsStream("/SoapTestCapabilities_ruth0.xml");
		LOGGER.info(client.request(input_cap));
	
		InputStream input_rp = client.getClass().getResourceAsStream("/SoapTestRegisterPublisher_ruth0.xml");
		LOGGER.info(client.request(input_rp));

	}
}
