/***************************************************************
Copyright 2007 52North Initiative for Geospatial Open Source Software GmbH

 Author: jtheuer, University of Muenster

 Contact: Andreas Wytzisk, 
 52North Initiative for Geospatial Open Source SoftwareGmbH, 
 Martin-Luther-King-Weg 24,
 48155 Muenster, Germany, 
 info@52north.org

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 version 2 as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; even without the implied WARRANTY OF
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program (see gnu-gpl v2.txt). If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA or visit the Free
 Software Foundations web page, http://www.fsf.org.

 ***************************************************************/

	
package org.n52.swe.sas.muse.wsbr;
import java.io.IOException;
import java.util.logging.Logger;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.muse.ws.addressing.soap.SoapFault;
import org.n52.swe.sas.muse.MuseTestCase;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * @author Jan Torben Heuer <jan.heuer@uni-muenster.de>
 *
 */
public class PublisherEndpointTestCase extends MuseTestCase {
	/* automatically generated Logger */@SuppressWarnings("unused")
	private static final Logger LOGGER = Logger.getLogger(PublisherEndpointTestCase.class.getName());
	private PublisherEndpoint pe;

	/**
	 * @param name
	 */
	public PublisherEndpointTestCase(String name) {
		super(name);
	}

	/* (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	@Override
	protected void setUp() throws Exception {
		super.setUp();
		this.pe = new PublisherEndpoint();
	}
	
	public final void testSensorML() throws SAXException, IOException, ParserConfigurationException, SoapFault {
		Document dom = readResourceAsDom("/testSensorML.txt");

		pe.setSensorML(dom.getDocumentElement());
		
		assertEquals(dom.getDocumentElement(),pe.getSensorML());
		assertEquals("urn:ogc:object:feature:Sensor:IFGI:ifgicam",pe.getSensorId());

	}
}
